CREATE OR ALTER procedure CALC_KOR_USL (
    ID_STATTALON integer,
    OGRN char(15),
    ID_FYS integer)
as
declare variable ID_USL integer;
declare variable KL integer;
declare variable ID_USL1 integer;
declare variable KO integer;
declare variable USL_C char(16);
declare variable SP char(3);
declare variable D_OK date;
begin
  KL = 0;
  KO = 0;
  ID_USL = 0;
  ID_USL1 = 0;
  /*KBD, ALFA,DNK*/
  if ((OGRN = '1034500006793') or (OGRN = '1054500002468') or (OGRN = '1074501007790') or (OGRN = '1034500013712')) then
  begin
    for select USL_OD.ID_USL_OD, USL_OD.D_OKAZ, USL_OD.K_USL_MZ
        from USL_OD, FYS2006
        where USL_OD.ID_STATTALON = :ID_STATTALON /* and usl_od.usl_code>0*/
              and
              USL_OD.K_USL_MZ = FYS2006.KOD_US_MZ and
              FYS2006.IDFYSMANUAL = :ID_FYS and
              ((USL_OD.K_USL_MZ = 'A26.08.008.001') and
              (USL_OD.D_OKAZ >= '01.08.2020'))
        into :ID_USL, :D_OK, :USL_C
    do
    begin /* for each id_stattalona */
      update USL_OD
      set USL_OD.USL_CODE = 0,
          USL_OD.PAID = 0
      where USL_OD.ID_USL_OD = :ID_USL;
    end /* for each id_stattalona and sp*/
  end
  else
  begin
    /*Vse LPU*/
    for select USL_OD.ID_USL_OD, USL_OD.D_OKAZ, USL_OD.K_USL_MZ, FYS2006.KOD_SP
        from USL_OD, FYS2006
        where USL_OD.ID_STATTALON = :ID_STATTALON /* and usl_od.usl_code>0*/
              and
              USL_OD.K_USL_MZ = FYS2006.KOD_US_MZ and
              FYS2006.IDFYSMANUAL = :ID_FYS and
              USL_OD.USL_CODE > 0
              /*and ((usl_od.k_usl_mz='A26.08.008.001') and (usl_od.d_okaz>='01.07.2020')) or ((fys2006.kod_sp='031') or (fys2006.kod_sp='026') or (fys2006.kod_sp='047'))*/
        into :ID_USL, :D_OK, :USL_C, :SP
    do
    begin /* for each id_stattalona */
      if ((USL_C = 'A26.08.008.001') and
          (D_OK >= '01.07.2020')) then
      begin
        KL = KL + 1;
        ID_USL1 = ID_USL;
      end
      if ((USL_C <> 'A26.08.008.001') and
          (SP in ('001', '004', '005', '008', '009', '010', '011', '014', '015', '018',
                  '023', '024', '025', '026', '027', '028', '029', '031', '037', '040',
                  '047', '050', '053', '057', '058'))) then
        KO = KO + 1;
    end /* for each id_stattalona and sp*/
    if ((KL > 0) and
        (KO = 0)) then
    begin
      update USL_OD
      set USL_OD.USL_CODE = 0,
          USL_OD.PAID = 0
      where USL_OD.ID_USL_OD = :ID_USL1;
    end
  end

end